/*->c.asprite */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"
#include "process.h"


#include "err.h"
#include "fsx.h"
#include "alloc.h"
#include "etc.h"
#include "bf.h"
#include "colour.h"
#include "deb.h"


#include "str.h"

#include "main.h"
#include "im.h"
#include "mask.h"

#include "asprite.h"




/*

  type 1  1bpp image 1bpp mask
       2  2bpp
       3  4bpp
       4  8bpp
       5  16bpp
       6  32bpp
       7  CMYK
       8  24bpp

  palette not supported by RISC OS 3.50, but is by 3.60


*/





//static ftypestr ftype;

static int bppmap[9]={0,1,2,4,8,16,32,32,24};

static int      deepsprites;  // if false force anything over 8bpp to 8bpp
static int      newformat;    // force to 1bpp mask for all bpp






typedef struct modestr
{
 char dx;
 char dy;
 char ln2bpp;
 char mask;

} modestr;



#define MAXMODE 128

static modestr modedata[MAXMODE]=
{
2,4,0,0x01,  // mode 0
4,4,1,0x03,  // mode 1
8,4,2,0x0f,  // mode 2
2,4,1,0x03,  // mode 3
4,4,0,0x01,  // mode 4
8,4,1,0x03,  // mode 5
4,4,1,0x03,  // mode 6
4,4,2,0x0f,  // mode 7
2,4,1,0x03,  // mode 8
4,4,2,0x0f,  // mode 9
8,4,3,0xff,  // mode 10
2,4,1,0x03,  // mode 11
2,4,2,0x0f,  // mode 12
4,4,3,0xff,  // mode 13
2,4,2,0x0f,  // mode 14
2,4,3,0xff,  // mode 15
2,4,2,0x0f,  // mode 16
2,4,2,0x0f,  // mode 17
2,2,0,0x01,  // mode 18
2,2,1,0x03,  // mode 19
2,2,2,0x0f,  // mode 20
2,2,3,0xff,  // mode 21
1,2,2,0x0f,  // mode 22
2,2,0,0x01,  // mode 23
2,4,3,0xff,  // mode 24
2,2,0,0x01,  // mode 25
2,2,1,0x03,  // mode 26
2,2,2,0x0f,  // mode 27
2,2,3,0xff,  // mode 28
2,2,0,0x01,  // mode 29
2,2,1,0x03,  // mode 30
2,2,2,0x0f,  // mode 31
2,2,3,0xff,  // mode 32
2,4,0,0x01,  // mode 33
2,4,1,0x03,  // mode 34
2,4,2,0x0f,  // mode 35
2,4,3,0xff,  // mode 36
2,4,0,0x01,  // mode 37
2,4,1,0x03,  // mode 38
2,4,2,0x0f,  // mode 39
2,4,3,0xff,  // mode 40
2,4,0,0x01,  // mode 41
2,4,1,0x03,  // mode 42
2,4,2,0x0f,  // mode 43
2,4,0,0x01,  // mode 44
2,4,1,0x03,  // mode 45
2,4,2,0x0f,  // mode 46
4,4,3,0xff,  // mode 47
4,2,2,0x0f,  // mode 48
4,2,3,0xff,  // mode 49
1,1,0,0x01,  // mode 50
1,1,0,0x01,  // mode 51
1,1,0,0x01,  // mode 52
1,1,0,0x01,  // mode 53
1,1,0,0x01,  // mode 54
1,1,0,0x01,  // mode 55
1,1,0,0x01,  // mode 56
1,1,0,0x01,  // mode 57
1,1,0,0x01,  // mode 58
1,1,0,0x01,  // mode 59
1,1,0,0x01,  // mode 60
1,1,0,0x01,  // mode 61
1,1,0,0x01,  // mode 62
1,1,0,0x01,  // mode 63
1,1,0,0x01,  // mode 64
1,1,0,0x01,  // mode 65
1,1,0,0x01,  // mode 66
1,1,0,0x01,  // mode 67
1,1,0,0x01,  // mode 68
1,1,0,0x01,  // mode 69
1,1,0,0x01,  // mode 70
1,1,0,0x01,  // mode 71
1,1,0,0x01,  // mode 72
1,1,0,0x01,  // mode 73
1,1,0,0x01,  // mode 74
1,1,0,0x01,  // mode 75
1,1,0,0x01,  // mode 76
1,1,0,0x01,  // mode 77
1,1,0,0x01,  // mode 78
1,1,0,0x01,  // mode 79
1,1,0,0x01,  // mode 80
1,1,0,0x01,  // mode 81
1,1,0,0x01,  // mode 82
1,1,0,0x01,  // mode 83
1,1,0,0x01,  // mode 84
1,1,0,0x01,  // mode 85
1,1,0,0x01,  // mode 86
1,1,0,0x01,  // mode 87
1,1,0,0x01,  // mode 88
1,1,0,0x01,  // mode 89
1,1,0,0x01,  // mode 90
1,1,0,0x01,  // mode 91
1,1,0,0x01,  // mode 92
1,1,0,0x01,  // mode 93
1,1,0,0x01,  // mode 94
1,1,0,0x01,  // mode 95
1,1,0,0x01,  // mode 96
1,1,0,0x01,  // mode 97
1,1,0,0x01,  // mode 98
1,1,0,0x01,  // mode 99
1,1,0,0x01,  // mode 100
1,1,0,0x01,  // mode 101
1,1,0,0x01,  // mode 102
1,1,0,0x01,  // mode 103
1,1,0,0x01,  // mode 104
1,1,0,0x01,  // mode 105
1,1,0,0x01,  // mode 106
1,1,0,0x01,  // mode 107
1,1,0,0x01,  // mode 108
1,1,0,0x01,  // mode 109
1,1,0,0x01,  // mode 110
1,1,0,0x01,  // mode 111
1,1,0,0x01,  // mode 112
1,1,0,0x01,  // mode 113
1,1,0,0x01,  // mode 114
1,1,0,0x01,  // mode 115
1,1,0,0x01,  // mode 116
1,1,0,0x01,  // mode 117
1,1,0,0x01,  // mode 118
1,1,0,0x01,  // mode 119
1,1,0,0x01,  // mode 120
1,1,0,0x01,  // mode 121
1,1,0,0x01,  // mode 122
1,1,0,0x01,  // mode 123
1,1,0,0x01,  // mode 124
1,1,0,0x01,  // mode 125
1,1,0,0x01,  // mode 126
1,1,0,0x01,  // mode 127

};





os_error * getdeltas(int mode,int * dx,int * dy)
{
 int xdpi;
 int ydpi;
 
 if((mode>>27) & 0x1F)
 {
  xdpi=(mode>>1) & 0x1FFF;
  if(xdpi==0) xdpi=90;
  *dx=180/xdpi;
  ydpi=(mode>>14) & 0x1FFF;
  if(ydpi==0) ydpi=90;
  *dy=180/ydpi;
 }
 else
 {
  mode&=0x7F;
  *dx=modedata[mode].dx;
  *dy=modedata[mode].dy;
 }

 return(NULL);
}



os_error * getbpp(int mode,int * rln2bpp,int * bitmask)
{

 mode&=0x7F;

 if(rln2bpp) *rln2bpp=modedata[mode].ln2bpp;
 if(bitmask) *bitmask=modedata[mode].mask;

 return(NULL);
}






typedef struct xmodestr
{
 int mode;
 int dx;
 int dy;
 int bpp;
 int mask;
} xmodestr;











static os_error * getpal(buffer * bf,imagestr * im,newsprite_header * sph)
{
 os_error * err;
 int        palentries;
 int        paltab[257];
 int        i;
 int        c1;

 err=NULL;


 palentries=(sph->image-sizeof(sprite_header))/8;
 if(palentries<0) palentries = 0;

 if(palentries==0)
 {
  if(im->bpp>8)
  {
   im->ipal.ncolours=0;
   memset(&im->ipal,0,sizeof(ipalstr));
   im->ipal.palclass=(sph->selector.type.type==7)?CL_CMYK:CL_RGB;
   return(err);
  }

  /* if there is no palette, we'd like it to look like wimp cols */

  if(im->bpp==8)
  {
   palentries=16;
   paltab[0]=0x0;
   paltab[1]=0x10101000;
   paltab[2]=0x20202000;
   paltab[3]=0x30303000;
   paltab[4]=0x4000;
   paltab[5]=0x10105000;
   paltab[6]=0x20206000;
   paltab[7]=0x30307000;
   paltab[8]=0x40000000;
   paltab[9]=0x50101000;
   paltab[10]=0x60202000;
   paltab[11]=0x70303000;
   paltab[12]=0x40004000;
   paltab[13]=0x50105000;
   paltab[14]=0x60206000;
   paltab[15]=0x70307000;
   palentries=16;
  }
  else
  if(im->bpp==4)
  {
   paltab[0]=0xffffff00;
   paltab[1]=0xdddddd00;
   paltab[2]=0xbbbbbb00;
   paltab[3]=0x99999900;
   paltab[4]=0x77777700;
   paltab[5]=0x55555500;
   paltab[6]=0x33333300;
   paltab[7]=0x00000000;
   paltab[8]=0x99440000;
   paltab[9]=0x00eeee00;
   paltab[10]=0x00cc0000;
   paltab[11]=0x0000dd00;
   paltab[12]=0xbbeeee00;
   paltab[13]=0x00885500;
   paltab[14]=0x00bbff00;
   paltab[15]=0xffbb0000;
   palentries=16;
  }
  else
  if(im->bpp==2)
  {
   paltab[0]=0xffffff00;
   paltab[1]=0xdddddd00;
   paltab[2]=0x99999900;
   paltab[3]=0x00000000;
   palentries=4;
  }
  else
  if(im->bpp==1)
  {
   paltab[0]=0xffffff00;
   paltab[1]=0x00000000;
   palentries=2;
  }
 }
 else
 {
  for(i=0;i<palentries;i++)
  {
   if(i<256) bf_read(bf,paltab+i,2*sizeof(int));
   else      bf_read(bf,paltab+256,2*sizeof(int));
  }
 }

 if(im->bpp==8 && (palentries==64 || palentries==16))
 {

  if(palentries==64)
  {
   for(i=0;i<16;i++) paltab[i]=paltab[i+48];
  }

  for(i=255;i>=0;i--)
  {
   c1=paltab[(i & 0xF)];

   if(i & 0x10) c1|=0x8000;
   else         c1&=~0x8000;

   if(i & 0x20) c1|=0x400000;
   else         c1&=~0x400000;

   if(i & 0x40) c1|=0x800000;
   else         c1&=~0x800000;

   if(i & 0x80) c1|=0x80000000;
   else         c1&=~0x80000000;

   c1&=0xF0F0F000;
   c1|=(c1>>4)&0xF0F0F00;

   paltab[i]=c1;
  }
  palentries=256;
 }

 im->ipal.ncolours=palentries;
 for(i=0;i<palentries;i++) im->ipal.word[i]=paltab[i];

 return(err);
}





os_error * spreadhdr(int fn,buffer * bf,newsprite_header * sph)
{
 os_error * err;
 char     * p;
 char     * q;
 int        spdx;
 int        spdy;
 int        spbpp;
 int        spbitmask;
 int        bitwidth;
 int        xdpi;
 int        ydpi;
 int        xpix;
 int        ypix;

 err=NULL;

 /* nb name is not zero terminated */

 if(sph->selector.type.type)  /* it is a new sprite */
 {
  xdpi=sph->selector.type.xdpi;
  ydpi=sph->selector.type.ydpi;
  spbpp=bppmap[sph->selector.type.type];

 /* dprintf(0,"xdpi=%d ydpi=%d bpp=%d type=%d",
             sph->selector.type.xdpi,sph->selector.type.ydpi,
             spbpp,sph->selector.type.type); */

  bitwidth=32*(sph->width+1)-(31-sph->rbit);
  xpix=bitwidth/spbpp;
  ypix=sph->height+1;
 }
 else
 {
  err=getdeltas(sph->selector.mode.mode,&spdx,&spdy);
  if(!err)
  {
   getbpp(sph->selector.mode.mode,&spbpp,&spbitmask);
   spbpp=(1<<spbpp);
  }

  bitwidth=32*(sph->width+1)-sph->lbit-(31-sph->rbit);

  xpix=bitwidth/spbpp;
  ypix=sph->height+1;

  xdpi=180/spdx;
  ydpi=180/spdy;
 }

 p=sph->name;
 q=loadfile->frames[fn].name;
 while(*p>=32) *q++=*p++;
 *q=0;


 loadfile->frames[fn].fbpp=spbpp;
 loadfile->frames[fn].fxdpi=xdpi;
 loadfile->frames[fn].fydpi=ydpi;
 loadfile->frames[fn].fxpix=xpix;
 loadfile->frames[fn].fypix=ypix;

 return(err);
 USE(bf);
}





os_error * sploadframe(filestr * file,buffer * bf,
                                                newsprite_header * sph,int fn)
{
 os_error * err;
 imagestr * loadimage;
 int        y;
 int      * idata;
 int        mbpp;
 int        mask;
 int        mwidth;
 int      * buff;



 if(sph->mask!=sph->image)
 {
  if(sph->selector.type.type)
  {
   mbpp=1;
   mwidth=((file->frames[fn].fxpix+0x1F) & (~0x1F))/8;
  }
  else
  {
   mbpp=file->frames[fn].fbpp;
   mwidth=(sph->width+1)*sizeof(int);
  }
 }
 else
 {
  mbpp=mwidth=0;
 }


 err=bf_tell(bf,&mask);
 mask-=sizeof(sprite_header);
 mask+=sph->mask;


 err=ximnew2(file->frames[fn].fxpix,file->frames[fn].fypix,
            file->frames[fn].fbpp,(mbpp>0)?1:0,&file->frames[fn].xim);
 if(!err)
 {
  loadimage=((file->frames[fn].xim)->sim[IM]);
  loadimage->xdpi=file->frames[fn].fxdpi;
  loadimage->ydpi=file->frames[fn].fydpi;

/*
dprintf(1,"ld=%x fn=%d file=%d xim=%d",loadimage,fn,file,(file->frames[fn].xim));
*/

  getpal(bf,loadimage,sph);

//  getinfo(&file->frames[fn],sph);

/* dprintf(0,"lbt %d rbit %d image=%d",sph->lbit,sph->rbit,sph->image); */


  for(y=0;y<file->frames[fn].fypix;y++)
  {
   err=imfind1w(loadimage,y,&idata);
   if(err) break;
   err=bf_read(bf,idata,(sph->width+1)*sizeof(int));
   if(err) break;
   if(sph->lbit) shiftline(idata,file->frames[fn].fxpix,
                                 file->frames[fn].fbpp,sph->lbit);
  }

  if(mbpp)
  {
   bf_seek(bf,mask);

   loadimage=((file->frames[fn].xim)->sim[AL]);

   imsetgreypal(loadimage,1);

   if(mbpp==1)
   {
    for(y=0;y<file->frames[fn].fypix;y++)
    {
     err=imfind1w(loadimage,y,&idata);
     if(err) break;
     err=bf_read(bf,idata,mwidth);
     if(err) break;
     if(sph->lbit) shiftline(idata,file->frames[fn].fxpix,
                                  1,(sph->lbit*mbpp)/file->frames[fn].fbpp);
    }
   }
   else
   if(mbpp!=0)
   {
    err=salloc((flex_ptr)&buff,mwidth);
    if(!err)
    {
     for(y=0;y<file->frames[fn].fypix;y++)
     {
      err=bf_read(bf,buff,mwidth);
      if(err) break;

      if(sph->lbit) shiftline(idata,file->frames[fn].fxpix,
                                  mbpp,(sph->lbit*mbpp)/file->frames[fn].fbpp);

      err=imfind1w(loadimage,y,&idata);
      if(err) break;

      maskcut(buff,mbpp,idata,1,file->frames[fn].fxpix);
     }
     sfree((flex_ptr)&buff);
    }
   }
  }
 }
 return(err);
}



os_error *loadasprite(char * name,int type,int userhandle,int xvolatile)
{
 os_error    * err;
 buffer        bf;
 sprite_area   spa;
 newsprite_header sph;
 int           i;
 int           next;
 int           fn;

 err=bf_open(name,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
  err=bf_read(&bf,&spa.number,sizeof(sprite_area)-sizeof(int));
  if(!err) err=bf_seek(&bf,spa.sproff-sizeof(int));
  if(!err)
  {
   for(i=0;i<spa.number;i++)
   {
    err=bf_tell(&bf,&next);
    if(err) break;

    err=bf_read(&bf,&sph,sizeof(sprite_header));
    if(err) break;

    err=addframe(loadfile,&fn,0);
    if(err) break;

    loadfile->frames[fn].offset=next;
    loadfile->frames[fn].xim=NULL;
    next+=sph.next;

    err=spreadhdr(fn,&bf,&sph);
    if(err) break;

    if(i==0)
    {
     err=sploadframe(loadfile,&bf,&sph,fn);
     if(err) break;
    }

    err=bf_seek(&bf,next);
    if(err) break;
   }
  }
  err=bf_close(&bf,err);
 }


 return(err);

 USE(type);
 USE(userhandle);
 USE(xvolatile);
}




static os_error * getframe(filestr * file,int fn)
{
 os_error    * err;
 buffer        bf;
 newsprite_header sph;

 err=bf_open(file->oname,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
           err=bf_seek(&bf,file->frames[fn].offset);
  if(!err) err=bf_read(&bf,&sph,sizeof(newsprite_header));
  if(!err) err=spreadhdr(fn,&bf,&sph);
  if(!err) err=sploadframe(loadfile,&bf,&sph,fn);

  err=bf_close(&bf,err);
 }
 return(err);
}




static int rpixmode[4]=
{
 0,4,12,15,
};

static int spixmode[4]=
{
 25,26,27,28,
};

static int getspmode(int bpp,int palclass,int xres,int yres,int newformat)
{
 int mode;
 int index;

 if(bpp<=8 && !newformat)
 {
  if(bpp==8) index=3;
  else
  if(bpp==4) index=2;
  else
  if(bpp==2) index=1;
  else       index=0;

  if(yres>=xres) mode=spixmode[index];  /* square */
  else           mode=rpixmode[index];
 }
 else
 {
  mode=1;

  if(yres>=xres) mode|=(90<<1)|(90<<14);
  else           mode|=(90<<1)|(45<<14);

  if(bpp==1)  mode|=(1<<27);
  else
  if(bpp==2)  mode|=(2<<27);
  else
  if(bpp==4)  mode|=(3<<27);
  else
  if(bpp==8)  mode|=(4<<27);
  else
  if(bpp==16) mode|=(5<<27);
  else
  {
   if(palclass==CL_CMYK) mode|=(7<<27);
   else                  mode|=(6<<27);
  }
 }
 return(mode);
}






#define DRAWW 16

static void dummysprite(int *buff,int size,int xpix,int ypix,int xdpi,int ydpi)
{
 char * p;
 char * q;
 int    xhi;
 int    yhi;


 xhi=(xpix*256*180)/xdpi;                         /* draw units */
 yhi=(ypix*256*180)/ydpi;

 strcpy((char *)buff,"Draw");
 *(buff+1)=201;
 *(buff+2)=0;
 p=(char*)(buff+3);
 q=p+12;
 strcpy(p,"DPPNG");
 p+=strlen(p);
 for(;p<q;p++) *p=32;

 *(buff+6)=0;
 *(buff+7)=0;
 *(buff+8)=xhi;
 *(buff+9)=yhi;

 *(buff+10)=5;
 *(buff+11)=size;

 *(buff+12)=0;
 *(buff+13)=0;
 *(buff+14)=xhi;
 *(buff+15)=yhi;
}







os_error * savespritesub(filestr * file,int fn,char * name,int type,int draw)
{
 os_error  * err;
 buffer      bf;
 int         xpix;
 int         ypix;
 int         sbpp;
 int         dbpp;
 int       * idata;
 imagestr  * saveimage;
 imagestr  * sim;
 imagestr  * mim;
 int         x;
 int         y;
 sprite_header sph;
 sprite_area   spa;
 char      * p;
 char      * q;
 int         i;
 int         palsize;
 int       * buff;
 int         dwwidth;
 int         tempimage;
 int         buffer[DRAWW];
 int         mbpp;
 int         msbpp;
 int         imsize;
 int         mwwidth;
 int         masksize;



 saveimage=sim=((file->frames[fn].xim)->sim[IM]);
           mim=((file->frames[fn].xim)->sim[AL]);

 tempimage=0;


 xpix=saveimage->xpix;
 ypix=saveimage->ypix;
 sbpp=saveimage->bpp;

 if(sbpp==24) dbpp=32;
 else         dbpp=sbpp;


 if(sbpp>32)
 {
  err=geterror(EBADBITS);

 }
 else
 {
  err=bf_open(name,'w',DEFBUFFSIZE,&bf);
  if(!err)
  {
   if(sbpp<=8) palsize=(1<<sbpp)*2*sizeof(int);
   else        palsize=0;


   dwwidth=((dbpp*xpix+0x1F)&(~0x1F))/32;

   imsize=dwwidth*ypix*sizeof(int);

   if(mim)
   {
    msbpp=mim->bpp;

    if(sbpp<=8 && !newformat) 
    {
     masksize=imsize;
     mwwidth=dwwidth;
     mbpp=sbpp;
    }
    else
    {
     mbpp=1;
     mwwidth=((mbpp*xpix+0x1F)&(~0x1F))/32;
     masksize=mwwidth*ypix*sizeof(int);
    }
   }
   else
   {
    masksize=mwwidth=mbpp=msbpp=0;
   }

   spa.number=1;
   spa.sproff=sizeof(sprite_area);
   spa.freeoff=sizeof(sprite_area)+
                      sizeof(sprite_header)+palsize+imsize+masksize;

   sph.next=sizeof(sprite_header)+palsize+imsize+masksize;

   p=sph.name;
   memset(p,0,sizeof(sph.name));
   q=file->frames[fn].name;
   while((*p++=(char)tolower(*q++))!=0);

   sph.width=dwwidth-1;
   sph.height=saveimage->ypix-1;
   sph.lbit=0;
   sph.rbit=(xpix*(dbpp)-1) % 32;
   sph.image=sizeof(sprite_header)+palsize;
   sph.mask=sph.image;
   if(mim) sph.mask+=imsize;
   sph.mode=getspmode(dbpp,saveimage->ipal.palclass,
                           saveimage->xdpi,saveimage->ydpi,newformat);


   dummysprite(buffer,sph.next+24,saveimage->xpix,saveimage->ypix,
                             saveimage->xdpi,saveimage->ydpi);

   if(draw) bf_write(&bf,buffer,DRAWW*sizeof(int));
   else     bf_write(&bf,&spa.number,sizeof(sprite_area)-sizeof(int));

   bf_write(&bf,&sph,sizeof(sprite_header));


   if(palsize)
   {
    for(i=0;i<(1<<dbpp);i++)
    {
     if(i<saveimage->ipal.ncolours)
     {
      bf_puti(&bf,saveimage->ipal.word[i]);
      bf_puti(&bf,saveimage->ipal.word[i]);
     }
     else
     {
      bf_puti(&bf,0);
      bf_puti(&bf,0);
     }
    }
   }


   if(sbpp==24)
   {
    err=salloc((flex_ptr)&buff,dwwidth*sizeof(int));
    if(!err)
    {
     for(y=0;y<ypix;y++)
     {
      err=imfind1r(saveimage,y,&idata);
      if(err) break;
      p=(char*)idata;
      q=(char*)buff;
      for(x=0;x<xpix;x++)
      {
       *q++=*p++;
       *q++=*p++;
       *q++=*p++;
       *q++=0;
      }
      err=bf_write(&bf,buff,dwwidth*sizeof(int));
      if(err) break;
     }
     sfree((flex_ptr)&buff);
    }
   }
   else
   {
    for(y=0;y<ypix;y++)
    {
     err=imfind1r(saveimage,y,&idata);
     if(err) break;
     err=bf_write(&bf,idata,dwwidth*sizeof(int));
     if(err) break;
    }
   }


   if(!err)
   {
    if(mim)
    {
     if(mbpp!=msbpp)
     {
      err=salloc((flex_ptr)&buff,mwwidth*sizeof(int));
      if(!err)
      {
       for(y=0;y<ypix;y++)
       {
        err=imfind1r(mim,y,&idata);
        if(err) break;

        maskcut(idata,msbpp,buff,mbpp,xpix);

        err=bf_write(&bf,buff,mwwidth*sizeof(int));
        if(err) break;
       }
       sfree((flex_ptr)&buff);
      }
     }
     else
     {
      for(y=0;y<ypix;y++)
      {
       err=imfind1r(mim,y,&idata);
       if(err) break;
       err=bf_write(&bf,idata,mwwidth*sizeof(int));
       if(err) break;
      }
     }
    }
   }


   err=bf_closec(&bf,err,name,type);

   if(tempimage) imtrash(&saveimage);
  }
 }
 return(err);
}





